@builtin "whitespace.ne"
@{%
  const lexer = require("../../../constants/genericLexer");
%}

@lexer lexer


Base -> ( ClipSource | ( ( BasicShape | GeometryBox ) ( __ ( BasicShape | GeometryBox ) ):* ) | "none" )
ClipSource -> Url
BasicShape -> ( InsetFunc | CircleFunc | EllipseFunc | PolygonFunc )
GeometryBox -> ( ShapeBox | "fill-box" | "stroke-box" | "view-box" )
Url -> ( "url(" [^)]:* ")" )
InsetFunc -> ( ( ( "inset(" __ ( LengthPercentage ( __ LengthPercentage ):? ( __ LengthPercentage ):? ( __ LengthPercentage ):? ) ) __ ( ( "round" __ BorderRadius ) ):? ) __ ")" )
CircleFunc -> ( ( ( "circle(" __ ( ShapeRadius ):? ) __ ( ( "at" __ Position ) ):? ) __ ")" )
EllipseFunc -> ( ( ( "ellipse(" __ ( ( ShapeRadius __ ShapeRadius ) ):? ) __ ( ( "at" __ Position ) ):? ) __ ")" )
PolygonFunc -> ( ( ( ( "polygon(" __ FillRule:? ) __ "," ) __ ( ( ( ( LengthPercentage __ LengthPercentage ) ) _ "," _):* ( ( LengthPercentage __ LengthPercentage ) ) ) ) __ ")" )
LengthPercentage -> ( Length | Percentage )
BorderRadius -> ( ( LengthPercentage ( __ LengthPercentage ):? ( __ LengthPercentage ):? ( __ LengthPercentage ):? ) __ ( ( "/" __ ( LengthPercentage ( __ LengthPercentage ):? ( __ LengthPercentage ):? ( __ LengthPercentage ):? ) ) ):? )
Length -> ( Length_numberWithUnit | "0" )
Length_numberWithUnit -> Number LengthUnit
Percentage -> Number "%"
Number -> ( %number | Integer )
LengthUnit -> ( "ch" | "cm" | "em" | "ex" | "fr" | "in" | "mm" | "pc" | "pt" | "px" | "q" | "rem" | "vh" | "vmax" | "vmin" | "vw" )
Integer -> %integer
ShapeRadius -> ( LengthPercentage | "closest-side" | "farthest-side" )
Position -> ( ( ( ( "left" | "center" | "right" | "top" | "bottom" | LengthPercentage ) ) | ( ( ( "left" | "center" | "right" | LengthPercentage ) ) __ ( ( "top" | "center" | "bottom" | LengthPercentage ) ) ) | ( ( ( ( "center" | ( ( ( "left" | "right" ) ) __ LengthPercentage:? ) ) ) __ ( ( "center" | ( ( ( "top" | "bottom" ) ) __ LengthPercentage:? ) ) ) ) | ( ( ( "center" | ( ( ( "top" | "bottom" ) ) __ LengthPercentage:? ) ) ) __ ( ( "center" | ( ( ( "left" | "right" ) ) __ LengthPercentage:? ) ) ) ) ) ) )
FillRule -> ( "nonzero" | "evenodd" )
ShapeBox -> ( Box | "margin-box" )
Box -> ( "border-box" | "padding-box" | "content-box" )