@builtin "whitespace.ne"
@{%
  const lexer = require("../../../constants/genericLexer");
%}

@lexer lexer


Base -> ( BlurFunc | BrightnessFunc | ContrastFunc | DropShadowFunc | GrayscaleFunc | HueRotateFunc | InvertFunc | OpacityFunc | SepiaFunc | SaturateFunc )
BlurFunc -> ( ( "blur(" __ Length ) __ ")" )
BrightnessFunc -> ( ( "brightness(" __ NumberPercentage ) __ ")" )
ContrastFunc -> ( ( "contrast(" __ ( NumberPercentage ) ) __ ")" )
DropShadowFunc -> ( ( ( "drop-shadow(" __ ( Length __ Length ( __ Length ):? ) ) __ Color:? ) __ ")" )
GrayscaleFunc -> ( ( "grayscale(" __ NumberPercentage ) __ ")" )
HueRotateFunc -> ( ( "hue-rotate(" __ Angle ) __ ")" )
InvertFunc -> ( ( "invert(" __ NumberPercentage ) __ ")" )
OpacityFunc -> ( ( "opacity(" __ ( NumberPercentage ) ) __ ")" )
SepiaFunc -> ( ( "sepia(" __ NumberPercentage ) __ ")" )
SaturateFunc -> ( ( "saturate(" __ NumberPercentage ) __ ")" )
Length -> ( Length_numberWithUnit | "0" )
Length_numberWithUnit -> Number LengthUnit
Number -> ( %number | Integer )
LengthUnit -> ( "ch" | "cm" | "em" | "ex" | "fr" | "in" | "mm" | "pc" | "pt" | "px" | "q" | "rem" | "vh" | "vmax" | "vmin" | "vw" )
Integer -> %integer
NumberPercentage -> ( Number | Percentage )
Percentage -> Number "%"
Color -> ( %color | NamedColor | DeprecatedSystemColor | "currentcolor" )
NamedColor -> ( "transparent" | "aliceblue" | "antiquewhite" | "aqua" | "aquamarine" | "azure" | "beige" | "bisque" | "black" | "blanchedalmond" | "blue" | "blueviolet" | "brown" | "burlywood" | "cadetblue" | "chartreuse" | "chocolate" | "coral" | "cornflowerblue" | "cornsilk" | "crimson" | "cyan" | "darkblue" | "darkcyan" | "darkgoldenrod" | "darkgray" | "darkgreen" | "darkgrey" | "darkkhaki" | "darkmagenta" | "darkolivegreen" | "darkorange" | "darkorchid" | "darkred" | "darksalmon" | "darkseagreen" | "darkslateblue" | "darkslategray" | "darkslategrey" | "darkturquoise" | "darkviolet" | "deeppink" | "deepskyblue" | "dimgray" | "dimgrey" | "dodgerblue" | "firebrick" | "floralwhite" | "forestgreen" | "fuchsia" | "gainsboro" | "ghostwhite" | "gold" | "goldenrod" | "gray" | "green" | "greenyellow" | "grey" | "honeydew" | "hotpink" | "indianred" | "indigo" | "ivory" | "khaki" | "lavender" | "lavenderblush" | "lawngreen" | "lemonchiffon" | "lightblue" | "lightcoral" | "lightcyan" | "lightgoldenrodyellow" | "lightgray" | "lightgreen" | "lightgrey" | "lightpink" | "lightsalmon" | "lightseagreen" | "lightskyblue" | "lightslategray" | "lightslategrey" | "lightsteelblue" | "lightyellow" | "lime" | "limegreen" | "linen" | "magenta" | "maroon" | "mediumaquamarine" | "mediumblue" | "mediumorchid" | "mediumpurple" | "mediumseagreen" | "mediumslateblue" | "mediumspringgreen" | "mediumturquoise" | "mediumvioletred" | "midnightblue" | "mintcream" | "mistyrose" | "moccasin" | "navajowhite" | "navy" | "oldlace" | "olive" | "olivedrab" | "orange" | "orangered" | "orchid" | "palegoldenrod" | "palegreen" | "paleturquoise" | "palevioletred" | "papayawhip" | "peachpuff" | "peru" | "pink" | "plum" | "powderblue" | "purple" | "rebeccapurple" | "red" | "rosybrown" | "royalblue" | "saddlebrown" | "salmon" | "sandybrown" | "seagreen" | "seashell" | "sienna" | "silver" | "skyblue" | "slateblue" | "slategray" | "slategrey" | "snow" | "springgreen" | "steelblue" | "tan" | "teal" | "thistle" | "tomato" | "turquoise" | "violet" | "wheat" | "white" | "whitesmoke" | "yellow" | "yellowgreen" )
DeprecatedSystemColor -> ( "ActiveBorder" | "ActiveCaption" | "AppWorkspace" | "Background" | "ButtonFace" | "ButtonHighlight" | "ButtonShadow" | "ButtonText" | "CaptionText" | "GrayText" | "Highlight" | "HighlightText" | "InactiveBorder" | "InactiveCaption" | "InactiveCaptionText" | "InfoBackground" | "InfoText" | "Menu" | "MenuText" | "Scrollbar" | "ThreeDDarkShadow" | "ThreeDFace" | "ThreeDHighlight" | "ThreeDLightShadow" | "ThreeDShadow" | "Window" | "WindowFrame" | "WindowText" )
Angle -> Number AngleUnit
AngleUnit -> ( "deg" | "grad" | "rad" | "turn" )