@builtin "whitespace.ne"
@{%
  const lexer = require("../../../constants/genericLexer");
%}

@lexer lexer


Base -> ( MediaNot | MediaAnd | MediaOr | MediaInParens )
MediaNot -> ( "not" __ MediaInParens )
MediaAnd -> ( MediaInParens __ ( _ ( ( "and" __ MediaInParens ) ) _ ):+ )
MediaOr -> ( MediaInParens __ ( _ ( ( "or" __ MediaInParens ) ) _ ):+ )
MediaInParens -> ( ( ( "(" __ MediaCondition ) __ ")" ) | MediaFeature | GeneralEnclosed )
MediaCondition -> ( MediaNot | MediaAnd | MediaOr | MediaInParens )
MediaFeature -> ( ( "(" __ ( ( MfPlain | MfBoolean | MfRange ) ) ) __ ")" )
GeneralEnclosed -> ( ( ( ( FunctionToken __ AnyValue ) __ ")" ) ) | ( ( ( "(" __ Ident ) __ AnyValue ) __ ")" ) )
MfPlain -> ( ( MfName __ ":" ) __ MfValue )
MfBoolean -> MfName
MfRange -> ( ( ( ( MfName __ ( ( [object Object] | [object Object] ) ):? ) __ [object Object]:? ) __ MfValue ) | ( ( ( MfValue __ ( ( [object Object] | [object Object] ) ):? ) __ [object Object]:? ) __ MfName ) | ( ( ( ( ( ( MfValue __ [object Object] ) __ [object Object]:? ) __ MfName ) __ [object Object] ) __ [object Object]:? ) __ MfValue ) | ( ( ( ( ( ( MfValue __ [object Object] ) __ [object Object]:? ) __ MfName ) __ [object Object] ) __ [object Object]:? ) __ MfValue ) )
MfName -> Ident
MfValue -> ( Number | Dimension | Ident | Ratio )
Ident -> [^ ]:+
Number -> ( %number | Integer )
Dimension -> ( Length | Frequency | Angle | Resolution | Time )
Ratio -> [0-9]:+ "/" [0-9]:+
Integer -> %integer
Length -> ( Length_numberWithUnit | "0" )
Length_numberWithUnit -> Number LengthUnit
Frequency -> ( Number FrequencyUnit )
Angle -> Number AngleUnit
Resolution -> Number ResolutionUnit
Time -> Number TimeUnit
LengthUnit -> ( "ch" | "cm" | "em" | "ex" | "fr" | "in" | "mm" | "pc" | "pt" | "px" | "q" | "rem" | "vh" | "vmax" | "vmin" | "vw" )
FrequencyUnit -> ( "hz" | "khz" )
AngleUnit -> ( "deg" | "grad" | "rad" | "turn" )
ResolutionUnit -> ( "dpcm" | "dpi" | "dppx" )
TimeUnit -> ( "ms" | "s" )
FunctionToken -> [^ ]:+
AnyValue -> [^ ]:+