@builtin "whitespace.ne"
@{%
  const lexer = require("../../../constants/genericLexer");
%}

@lexer lexer


Base -> ( Number | Dimension | Ident | Ratio )
Number -> ( %number | Integer )
Dimension -> ( Length | Frequency | Angle | Resolution | Time )
Ident -> [^ ]:+
Ratio -> [0-9]:+ "/" [0-9]:+
Integer -> %integer
Length -> ( Length_numberWithUnit | "0" )
Length_numberWithUnit -> Number LengthUnit
Frequency -> ( Number FrequencyUnit )
Angle -> Number AngleUnit
Resolution -> Number ResolutionUnit
Time -> Number TimeUnit
LengthUnit -> ( "ch" | "cm" | "em" | "ex" | "fr" | "in" | "mm" | "pc" | "pt" | "px" | "q" | "rem" | "vh" | "vmax" | "vmin" | "vw" )
FrequencyUnit -> ( "hz" | "khz" )
AngleUnit -> ( "deg" | "grad" | "rad" | "turn" )
ResolutionUnit -> ( "dpcm" | "dpi" | "dppx" )
TimeUnit -> ( "ms" | "s" )